/**
 * \file
 *
 * \brief USBulԲ̪-u(HID)̪
 *
 * 쌠 (c) 2009 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udd.h"
#include "udc.h"
#include "udi_hid.h"


/**
 * \addtogroup udi_hid_group
 * @{
 */

/**
 * \name ٰ
 */
//@{

/**
 * \brief SETUPvɂċ߂ꂽLqq𑗏o
 *
 * \retval	true	Lqqxꍇ
 */
static bool udi_hid_reqstdifaceget_descriptor(uint8_t *report_desc);

//@}

bool udi_hid_setup( uint8_t *rate, uint8_t *protocol, uint8_t *report_desc, bool (*set_report)(void) )
{
	if (Udd_setup_is_in()) {
		// ̪擾v
		if (Udd_setup_type() == USB_REQ_TYPE_STANDARD) {
			// W̪擾v
			switch (udd_g_ctrlreq.req.bRequest) {

			case USB_REQ_GET_DESCRIPTOR:
				return udi_hid_reqstdifaceget_descriptor(report_desc);
			}
		}
		if (Udd_setup_type() == USB_REQ_TYPE_CLASS) {
			// ׽ ̪擾v
			switch (udd_g_ctrlreq.req.bRequest) {

			case USB_REQ_HID_GET_REPORT:
				// ׂ
				break;

			case USB_REQ_HID_GET_IDLE:
				udd_g_ctrlreq.payload = rate;
				udd_g_ctrlreq.payload_size = 1;
				return true;

			case USB_REQ_HID_GET_PROTOCOL:
				udd_g_ctrlreq.payload = protocol;
				udd_g_ctrlreq.payload_size = 1;
				return true;
			}
		}
	}
	if (Udd_setup_is_out()) {
		// ̪ݒv
		if (Udd_setup_type() == USB_REQ_TYPE_CLASS) {
			// ׽ ̪ݒv
			switch (udd_g_ctrlreq.req.bRequest) {

			case USB_REQ_HID_SET_REPORT:
				return set_report();

			case USB_REQ_HID_SET_IDLE:
				*rate = udd_g_ctrlreq.req.wValue >> 8;
				return true;

			case USB_REQ_HID_SET_PROTOCOL:
				if (0 != udd_g_ctrlreq.req.wLength)
					return false;
				*protocol = udd_g_ctrlreq.req.wValue;
				return true;
			}
		}
	}
	return false;	// xv
}


//---------------------------------------------
//------- ٰ

static bool udi_hid_reqstdifaceget_descriptor(uint8_t *report_desc)
{
	usb_hid_descriptor_t UDC_DESC_STORAGE *ptr_hid_desc;

	// ̪LqqɒuꂽUSBLqq擾
	// ̋LqqHIDLqqłȂ΂Ȃ܂B
	ptr_hid_desc = (usb_hid_descriptor_t UDC_DESC_STORAGE *) ((uint8_t *)
			udc_get_interface_desc() + sizeof(usb_iface_desc_t));
	if (USB_DT_HID != ptr_hid_desc->bDescriptorType)
		return false;

	// SETUPv͈ȉ₤Ƃł܂B:
	// - USB_DT_HIDLqqA܂
	// - USB_DT_HID_REPORTLqqA܂
	// - USB_DT_HID_PHYSICALLqq
	if (USB_DT_HID == (uint8_t) (udd_g_ctrlreq.req.wValue >> 8)) {
		// vꂽUSB_DT_HIDLqq̌ɑo
		udd_g_ctrlreq.payload = (uint8_t *) ptr_hid_desc;
		udd_g_ctrlreq.payload_size =
				min(udd_g_ctrlreq.req.wLength,
				ptr_hid_desc->bLength);
		return true;
	}
	// vꂽHID_XLqqHIDLqqŊ܂߂ꂽ񍐌^ɑΉȂ΂Ȃ
	// B
	if (ptr_hid_desc->bRDescriptorType ==
			(uint8_t) (udd_g_ctrlreq.req.wValue >> 8)) {
		// ʂɂė^ꂽHID񍐋Lqq𑗏o
		udd_g_ctrlreq.payload = report_desc;
		udd_g_ctrlreq.payload_size =
				min(udd_g_ctrlreq.req.wLength,
				le16_to_cpu(ptr_hid_desc->wDescriptorLength));
		return true;
	}
	return false;
}

//@}
